package com.offcn.api.tk.app3;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.util.HashMap;
import java.util.Map;

import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.TK;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;




/**
 * 
 * @Description:   17.智能批改-获取主观题解析
 *                 55.智能批改-获取主观题解析（该接口只给nwn使用）
 * @author: wff    
 * @date: 2019年6月12日 下午4:45:27   
 * @version V1.0
 */
public class getExpoundingStepExplain extends TK implements API {
	public String parameter;//参数集合
	
	public String record_id;//record_sub_id
	public String user_id;//用户id
	public String orgin;//来源 0为来自练习册,1为来自正常做题试卷,2扫描二维码试卷做题,3为来自模考大赛做题试卷
	public String exam_id;//考试id
	public String channel;//1题库 2nwn
	public String origin_id;//试卷或者练习册id
//	public String show_part_id;//用于控制某部分的显示与隐藏 1：作答内容 2:作答内容和解析 3：作答内容、解析、智能批改
//	public String paper_release;//试卷是否为人工批改，1：是，0：否（默认值为0）

	@Override
	public void initialize(HashMap<String, Object> data) {
		if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
			cleanUser_FromDB();//清除注册用户根据user_id
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		record_id = MapUtil.getParameter(parameter, "record_id").trim();
		user_id = MapUtil.getParameter(parameter, "user_id").trim();
		orgin = MapUtil.getParameter(parameter, "orgin").trim();
		exam_id = MapUtil.getParameter(parameter, "exam_id").trim();
		channel = MapUtil.getParameter(parameter, "channel").trim();
		origin_id = MapUtil.getParameter(parameter, "origin_id").trim();
		
		if ((!user_id.equals("")) && user_id.equals("code")) {
			user_id=ListUtil.getListValue(user_idList,0);
			parameter = parameter.replace("\"user_id\":code", "\"user_id\":\""+ user_id + "\"");
		}
		if ((!record_id.equals("")) && record_id.equals("code")) {
			record_id = record_id_L;
			parameter = parameter.replace("\"record_id\":code", "\"record_id\":\""+ record_id + "\"");
		}
		if ((!exam_id.equals("")) && exam_id.equals("code")) {
			exam_id = L_exam_id;
			parameter = parameter.replace("\"exam_id\":code", "\"exam_id\":\""+ exam_id + "\"");
		}
		if ((!origin_id.equals("")) && origin_id.equals("code")) {
			origin_id = paper_id_L;
			parameter = parameter.replace("\"origin_id\":code", "\"origin_id\":\""+ origin_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, String> headers=new HashMap<String, String>();
		headers.put("Authorization", tk_token);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setHeaders(headers);
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = StringUtils.decodeUnicode(re.asString());

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			if("0".equals(code)){
				
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
